package de.aaron;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.CrossOrigin;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

@Controller
@RequestMapping("/backend")
@CrossOrigin(origins = "*")
public class MicroserviceBackendController {

	@Autowired
	private MicroserviceBackendRepository repository;

	@RequestMapping(value = "/", method = RequestMethod.GET, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<?> getEntries() {
		List<Entry> entries = repository.findAllByOrderByIdDesc();
		return ResponseEntity.ok(entries);
	}

	@RequestMapping(value = "/", method = RequestMethod.PUT, consumes = MediaType.APPLICATION_JSON_VALUE, produces = MediaType.APPLICATION_JSON_VALUE)
	public ResponseEntity<?> insertEntry(@RequestBody Entry entry) {
		entry = repository.save(entry);
		return ResponseEntity.ok(entry);
	}

}
